#include "listas_int.h"
module ListaInt
where


import Foreign
import Foreign.C.Types


data Cel = Cel CInt (Ptr Cel)
type ListaInt = Ptr Cel

listaVazia :: IO ListaInt
listaVazia = return nullPtr

instance Storable Cel where
  sizeOf _ = #const sizeof (celula)
  poke ptr (Cel i p) = do
    (#poke celula, elem) ptr i
    (#poke celula, next) ptr p
  peek ptr = do
    item <- (#peek celula, elem) ptr
    p <- (#peek celula, next) ptr
    return (Cel item p)
  alignment = error "nyi"



foreign import ccall "Vazia" prim_vazia :: Ptr Cel -> IO CInt
vazia :: ListaInt -> Bool
vazia l = toBool (unsafePerformIO $ prim_vazia l)

foreign import ccall "Pertence" prim_pertence :: CInt -> Ptr Cel -> IO CInt
pertence :: Int -> ListaInt -> Bool
pertence x l = toBool $ unsafePerformIO (prim_pertence (fromIntegral x) l)

foreign import ccall "Ins" prim_ins :: CInt -> Ptr Cel -> IO (Ptr Cel)
ins :: Int -> ListaInt -> IO ListaInt
ins x l = prim_ins (fromIntegral x) l
